# ----------------------------------------------------------------------------
#     _____
#    /     \
#   /____   \____
#  / \===\   \==/
# /___\===\___\/  AVNET Design Resource Center
#      \======/         www.em.avnet.com/drc
#       \====/    
# ----------------------------------------------------------------------------
#  
#  This design is the property of Avnet.  Publication of this
#  design is not authorized without written consent from Avnet.
#  
# 
#  Disclaimer:
#     Avnet, Inc. makes no warranty for the use of this code or design.
#     This code is provided  "As Is". Avnet, Inc assumes no responsibility for
#     any errors, which may appear in this code, nor does it make a commitment
#     to update the information contained herein. Avnet, Inc specifically
#     disclaims any implied warranties of fitness for a particular purpose.
#                      Copyright(c) 2009 Avnet, Inc.
#                              All rights reserved.
# 
# ----------------------------------------------------------------------------
 
 
## 200MHz System Clock
set_property LOC G9 [ get_ports CLK_N]
set_property IOSTANDARD LVDS [ get_ports CLK_N]

set_property LOC H9 [ get_ports CLK_P]
set_property IOSTANDARD LVDS [ get_ports CLK_P]


## User LEDs
set_property LOC C6 [ get_ports LEDs_8Bits_tri_o[0]]
set_property IOSTANDARD LVCMOS15 [ get_ports LEDs_8Bits_tri_o[0]]

set_property LOC B6 [ get_ports LEDs_8Bits_tri_o[1]]
set_property IOSTANDARD LVCMOS15 [ get_ports LEDs_8Bits_tri_o[1]]

set_property LOC L9 [ get_ports LEDs_8Bits_tri_o[2]]
set_property IOSTANDARD LVCMOS15 [ get_ports LEDs_8Bits_tri_o[2]]

set_property LOC L10 [ get_ports LEDs_8Bits_tri_o[3]]
set_property IOSTANDARD LVCMOS15 [ get_ports LEDs_8Bits_tri_o[3]]

set_property LOC K10 [ get_ports LEDs_8Bits_tri_o[4]]
set_property IOSTANDARD LVCMOS15 [ get_ports LEDs_8Bits_tri_o[4]]

set_property LOC K11 [ get_ports LEDs_8Bits_tri_o[5]]
set_property IOSTANDARD LVCMOS15 [ get_ports LEDs_8Bits_tri_o[5]]

set_property LOC L12 [ get_ports LEDs_8Bits_tri_o[6]]
set_property IOSTANDARD LVCMOS15 [ get_ports LEDs_8Bits_tri_o[6]]

set_property LOC K12 [ get_ports LEDs_8Bits_tri_o[7]]
set_property IOSTANDARD LVCMOS15 [ get_ports LEDs_8Bits_tri_o[7]]



## User DIP Switches
set_property LOC C7 [ get_ports DIP_Switches_8Bits_tri_i[0]]
set_property IOSTANDARD LVCMOS15 [ get_ports DIP_Switches_8Bits_tri_i[0]]

set_property LOC B7 [ get_ports DIP_Switches_8Bits_tri_i[1]]
set_property IOSTANDARD LVCMOS15 [ get_ports DIP_Switches_8Bits_tri_i[1]]

set_property LOC A7 [ get_ports DIP_Switches_8Bits_tri_i[2]]
set_property IOSTANDARD LVCMOS15 [ get_ports DIP_Switches_8Bits_tri_i[2]]

set_property LOC B9 [ get_ports DIP_Switches_8Bits_tri_i[3]]
set_property IOSTANDARD LVCMOS15 [ get_ports DIP_Switches_8Bits_tri_i[3]]

set_property LOC A8 [ get_ports DIP_Switches_8Bits_tri_i[4]]
set_property IOSTANDARD LVCMOS15 [ get_ports DIP_Switches_8Bits_tri_i[4]]

set_property LOC A9 [ get_ports DIP_Switches_8Bits_tri_i[5]]
set_property IOSTANDARD LVCMOS15 [ get_ports DIP_Switches_8Bits_tri_i[5]]

set_property LOC B10 [ get_ports DIP_Switches_8Bits_tri_i[6]]
set_property IOSTANDARD LVCMOS15 [ get_ports DIP_Switches_8Bits_tri_i[6]]

set_property LOC A10 [ get_ports DIP_Switches_8Bits_tri_i[7]]
set_property IOSTANDARD LVCMOS15 [ get_ports DIP_Switches_8Bits_tri_i[7]]



## User Push Switches
set_property LOC B14 [ get_ports Push_Switches_3Bits_tri_i[0]]
set_property IOSTANDARD LVCMOS18 [ get_ports Push_Switches_3Bits_tri_i[0]]

set_property LOC A14 [ get_ports Push_Switches_3Bits_tri_i[1]]
set_property IOSTANDARD LVCMOS18 [ get_ports Push_Switches_3Bits_tri_i[1]]

set_property LOC A13 [ get_ports Push_Switches_3Bits_tri_i[2]]
set_property IOSTANDARD LVCMOS18 [ get_ports Push_Switches_3Bits_tri_i[2]]

set_property LOC A12 [ get_ports Push_Switches_3Bits_tri_i[3]]
set_property IOSTANDARD LVCMOS18 [ get_ports Push_Switches_3Bits_tri_i[3]]



## ARM PJTAG Header
set_property LOC R17 [ get_ports PJTAG_TCK]
set_property IOSTANDARD LVCMOS25 [ get_ports PJTAG_TCK]

set_property LOC T17 [ get_ports PJTAG_TMS]
set_property IOSTANDARD LVCMOS25 [ get_ports PJTAG_TMS]

set_property LOC N26 [ get_ports PJTAG_TD_I]
set_property IOSTANDARD LVCMOS25 [ get_ports PJTAG_TD_I]

set_property LOC N27 [ get_ports PJTAG_TD_O]
set_property IOSTANDARD LVCMOS25 [ get_ports PJTAG_TD_O]



## PL I2C Interface
set_property LOC B15 [ get_ports IIC_SCL]
set_property IOSTANDARD LVCMOS18 [ get_ports IIC_SCL]

set_property LOC A15 [ get_ports IIC_EEPROM_SDA]
set_property IOSTANDARD LVCMOS18 [ get_ports IIC_EEPROM_SDA]



## Audio Codec Interface
set_property LOC C12 [ get_ports AUD_ADR0]
set_property IOSTANDARD LVCMOS18 [ get_ports AUD_ADR0]

set_property LOC B12 [ get_ports AUD_ADR1]
set_property IOSTANDARD LVCMOS18 [ get_ports AUD_ADR1]

set_property LOC C17 [ get_ports AUD_GPIO0]
set_property IOSTANDARD LVCMOS18 [ get_ports AUD_GPIO0]

set_property LOC B16 [ get_ports AUD_GPIO1]
set_property IOSTANDARD LVCMOS18 [ get_ports AUD_GPIO1]

set_property LOC B17 [ get_ports AUD_GPIO2]
set_property IOSTANDARD LVCMOS18 [ get_ports AUD_GPIO2]

set_property LOC A17 [ get_ports AUD_GPIO3]
set_property IOSTANDARD LVCMOS18 [ get_ports AUD_GPIO3]

set_property LOC C14 [ get_ports AUD_MCLK]
set_property IOSTANDARD LVCMOS18 [ get_ports AUD_MCLK]



## LVDS Touch Panel Interface
set_property LOC T25 [ get_ports D0_N]
set_property IOSTANDARD LVDS [ get_ports D0_N]

set_property LOC T24 [ get_ports D0_P]
set_property IOSTANDARD LVDS [ get_ports D0_P]

set_property LOC V22 [ get_ports D1_N]
set_property IOSTANDARD LVDS [ get_ports D1_N]

set_property LOC U22 [ get_ports D1_P]
set_property IOSTANDARD LVDS [ get_ports D1_P]

set_property LOC T23 [ get_ports D2_N]
set_property IOSTANDARD LVDS [ get_ports D2_N]

set_property LOC T22 [ get_ports D2_P]
set_property IOSTANDARD LVDS [ get_ports D2_P]

set_property LOC P26 [ get_ports D3_N]
set_property IOSTANDARD LVDS [ get_ports D3_N]

set_property LOC P25 [ get_ports D3_P]
set_property IOSTANDARD LVDS [ get_ports D3_P]

set_property LOC AA20 [ get_ports LVDS_IRQ_N]
set_property IOSTANDARD LVCMOS33 [ get_ports LVDS_IRQ_N]



## HDMI Interface
set_property LOC E15 [ get_ports HDMI_CLK]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_CLK]

set_property LOC G17 [ get_ports HDMI_D8]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_D8]

set_property LOC G16 [ get_ports HDMI_D9]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_D9]

set_property LOC H16 [ get_ports HDMI_D10]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_D10]

set_property LOC J16 [ get_ports HDMI_D11]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_D11]

set_property LOC G15 [ get_ports HDMI_D12]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_D12]

set_property LOC F15 [ get_ports HDMI_D13]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_D13]

set_property LOC J15 [ get_ports HDMI_D14]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_D14]

set_property LOC K15 [ get_ports HDMI_D15]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_D15]

set_property LOC F14 [ get_ports HDMI_D16]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_D16]

set_property LOC G14 [ get_ports HDMI_D17]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_D17]

set_property LOC F13 [ get_ports HDMI_D18]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_D18]

set_property LOC G12 [ get_ports HDMI_D19]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_D19]

set_property LOC E13 [ get_ports HDMI_D20]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_D20]

set_property LOC D13 [ get_ports HDMI_D21]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_D21]

set_property LOC F12 [ get_ports HDMI_D22]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_D22]

set_property LOC E12 [ get_ports HDMI_D23]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_D23]

set_property LOC E16 [ get_ports HDMI_DE]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_DE]

set_property LOC D14 [ get_ports HDMI_HSYNC]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_HSYNC]

set_property LOC D16 [ get_ports HDMI_INT]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_INT]

set_property LOC F17 [ get_ports HDMI_SPDIF]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_SPDIF]

set_property LOC E17 [ get_ports HDMI_SPDIF_OUT]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_SPDIF_OUT]

set_property LOC D15 [ get_ports HDMI_VSYNC]
set_property IOSTANDARD LVCMOS18 [ get_ports HDMI_VSYNC]



## GTX Bank 109 (FMC HPC Slot)
set_property  LOC AE7 [ get_ports DP0_C2M_N]
set_property  LOC AE8 [ get_ports DP0_C2M_P]
set_property  LOC AH9 [ get_ports DP0_M2C_N]
set_property  LOC AH10[ get_ports DP0_M2C_P]
set_property  LOC AJ3 [ get_ports DP1_C2M_N]
set_property  LOC AJ4 [ get_ports DP1_C2M_P]
set_property  LOC AD5 [ get_ports DP1_M2C_N]
set_property  LOC AD6 [ get_ports DP1_M2C_P]
set_property  LOC AG3 [ get_ports DP2_C2M_N]
set_property  LOC AG4 [ get_ports DP2_C2M_P]
set_property  LOC AK9 [ get_ports DP2_M2C_N]
set_property  LOC AK10[ get_ports DP2_M2C_P]
set_property  LOC AK1 [ get_ports DP3_C2M_N]
set_property  LOC AK2 [ get_ports DP3_C2M_P]
set_property  LOC AG7 [ get_ports DP3_M2C_N]
set_property  LOC AG8 [ get_ports DP3_M2C_P]
set_property  LOC AD10[ get_ports GCLK0_M2C_P]
set_property  LOC AD9 [ get_ports GCLK0_M2C_N]

set_property  IOSTANDARD LVDS [ get_ports DP0_C2M_N]
set_property  IOSTANDARD LVDS [ get_ports DP0_C2M_P]
set_property  IOSTANDARD LVDS [ get_ports DP0_M2C_N]
set_property  IOSTANDARD LVDS [ get_ports DP0_M2C_P]
set_property  IOSTANDARD LVDS [ get_ports DP1_C2M_N]
set_property  IOSTANDARD LVDS [ get_ports DP1_C2M_P]
set_property  IOSTANDARD LVDS [ get_ports DP1_M2C_N]
set_property  IOSTANDARD LVDS [ get_ports DP1_M2C_P]
set_property  IOSTANDARD LVDS [ get_ports DP2_C2M_N]
set_property  IOSTANDARD LVDS [ get_ports DP2_C2M_P]
set_property  IOSTANDARD LVDS [ get_ports DP2_M2C_N]
set_property  IOSTANDARD LVDS [ get_ports DP2_M2C_P]
set_property  IOSTANDARD LVDS [ get_ports DP3_C2M_N]
set_property  IOSTANDARD LVDS [ get_ports DP3_C2M_P]
set_property  IOSTANDARD LVDS [ get_ports DP3_M2C_N]
set_property  IOSTANDARD LVDS [ get_ports DP3_M2C_P]
set_property  IOSTANDARD LVDS [ get_ports GCLK0_M2C_P]
set_property  IOSTANDARD LVDS [ get_ports GCLK0_M2C_N]



## GTX BANK 110 (FMC HPC Slot)
set_property  LOC AF1 [ get_ports DP4_C2M_N]
set_property  LOC AF2 [ get_ports DP4_C2M_P]
set_property  LOC AF5 [ get_ports DP4_M2C_N]
set_property  LOC AF6 [ get_ports DP4_M2C_P]
set_property  LOC AD1 [ get_ports DP5_C2M_N]
set_property  LOC AD2 [ get_ports DP5_C2M_P]
set_property  LOC AH5 [ get_ports DP5_M2C_N]
set_property  LOC AH6 [ get_ports DP5_M2C_P]
set_property  LOC AE3 [ get_ports DP6_C2M_N]
set_property  LOC AE4 [ get_ports DP6_C2M_P]
set_property  LOC AK5 [ get_ports DP6_M2C_N]
set_property  LOC AK6 [ get_ports DP6_M2C_P]
set_property  LOC AH1 [ get_ports DP7_C2M_N]
set_property  LOC AH2 [ get_ports DP7_C2M_P]
set_property  LOC AJ7 [ get_ports DP7_M2C_N]
set_property  LOC AJ8 [ get_ports DP7_M2C_P]
set_property  LOC AA8 [ get_ports GCLK1_M2C_P]
set_property  LOC AA7 [ get_ports GCLK1_M2C_N]

set_property  IOSTANDARD LVDS [ get_ports DP4_C2M_N]
set_property  IOSTANDARD LVDS [ get_ports DP4_C2M_P]
set_property  IOSTANDARD LVDS [ get_ports DP4_M2C_N]
set_property  IOSTANDARD LVDS [ get_ports DP4_M2C_P]
set_property  IOSTANDARD LVDS [ get_ports DP5_C2M_N]
set_property  IOSTANDARD LVDS [ get_ports DP5_C2M_P]
set_property  IOSTANDARD LVDS [ get_ports DP5_M2C_N]
set_property  IOSTANDARD LVDS [ get_ports DP5_M2C_P]
set_property  IOSTANDARD LVDS [ get_ports DP6_C2M_N]
set_property  IOSTANDARD LVDS [ get_ports DP6_C2M_P]
set_property  IOSTANDARD LVDS [ get_ports DP6_M2C_N]
set_property  IOSTANDARD LVDS [ get_ports DP6_M2C_P]
set_property  IOSTANDARD LVDS [ get_ports DP7_C2M_N]
set_property  IOSTANDARD LVDS [ get_ports DP7_C2M_P]
set_property  IOSTANDARD LVDS [ get_ports DP7_M2C_N]
set_property  IOSTANDARD LVDS [ get_ports DP7_M2C_P]
set_property  IOSTANDARD LVDS [ get_ports GCLK1_M2C_P]
set_property  IOSTANDARD LVDS [ get_ports GCLK1_M2C_N]



## GTX BANK 111 (SATA and SFP)
set_property  LOC AB5 [ get_ports SATA_RX_N]
set_property  LOC AB6 [ get_ports SATA_RX_P]
set_property  LOC Y1  [ get_ports SATA_TX_N]
set_property  LOC Y2  [ get_ports SATA_TX_P]
set_property  LOC AC3 [ get_ports SFP_RX_N]
set_property  LOC AC4 [ get_ports SFP_RX_P]
set_property  LOC AB1 [ get_ports SFP_TX_N]
set_property  LOC AB2 [ get_ports SFP_TX_P]
set_property  LOC U7  [ get_ports LVDS_CLK_N]
set_property  LOC U8  [ get_ports LVDS_CLK_P]
set_property  LOC W7  [ get_ports SATA_CLK_N]
set_property  LOC W8  [ get_ports SATA_CLK_P]

set_property  IOSTANDARD LVDS [ get_ports SATA_RX_N]
set_property  IOSTANDARD LVDS [ get_ports SATA_RX_P]
set_property  IOSTANDARD LVDS [ get_ports SATA_TX_N]
set_property  IOSTANDARD LVDS [ get_ports SATA_TX_P]
set_property  IOSTANDARD LVDS [ get_ports SFP_RX_N]
set_property  IOSTANDARD LVDS [ get_ports SFP_RX_P]
set_property  IOSTANDARD LVDS [ get_ports SFP_TX_N]
set_property  IOSTANDARD LVDS [ get_ports SFP_TX_P]
set_property  IOSTANDARD LVDS [ get_ports LVDS_CLK_N]
set_property  IOSTANDARD LVDS [ get_ports LVDS_CLK_P]
set_property  IOSTANDARD LVDS [ get_ports SATA_CLK_N]
set_property  IOSTANDARD LVDS [ get_ports SATA_CLK_P]



## GTX BANK 112 (PCIE)
set_property  LOC N3 [ get_ports T0_N]               
set_property  LOC N4 [ get_ports T0_P]               
set_property  LOC P5 [ get_ports PER0_N]             
set_property  LOC P6 [ get_ports PER0_P]             
set_property  LOC P1 [ get_ports T1_N]               
set_property  LOC P2 [ get_ports T1_P]               
set_property  LOC T5 [ get_ports PER1_N]             
set_property  LOC T6 [ get_ports PER1_P]             
set_property  LOC R3 [ get_ports T2_N]               
set_property  LOC R4 [ get_ports T2_P]               
set_property  LOC U3 [ get_ports PER2_N]             
set_property  LOC U4 [ get_ports PER2_P]             
set_property  LOC T1 [ get_ports T3_N]               
set_property  LOC T2 [ get_ports T3_P]               
set_property  LOC V5 [ get_ports PER3_N]             
set_property  LOC V6 [ get_ports PER3_P]             
set_property  LOC N7 [ get_ports MRCLK_N]            
set_property  LOC N8 [ get_ports MRCLK_P]            

set_property  IOSTANDARD LVDS [ get_ports T0_N]               
set_property  IOSTANDARD LVDS [ get_ports T0_P]               
set_property  IOSTANDARD LVDS [ get_ports PER0_N]             
set_property  IOSTANDARD LVDS [ get_ports PER0_P]             
set_property  IOSTANDARD LVDS [ get_ports T1_N]               
set_property  IOSTANDARD LVDS [ get_ports T1_P]               
set_property  IOSTANDARD LVDS [ get_ports PER1_N]             
set_property  IOSTANDARD LVDS [ get_ports PER1_P]             
set_property  IOSTANDARD LVDS [ get_ports T2_N]               
set_property  IOSTANDARD LVDS [ get_ports T2_P]               
set_property  IOSTANDARD LVDS [ get_ports PER2_N]             
set_property  IOSTANDARD LVDS [ get_ports PER2_P]             
set_property  IOSTANDARD LVDS [ get_ports T3_N]               
set_property  IOSTANDARD LVDS [ get_ports T3_P]               
set_property  IOSTANDARD LVDS [ get_ports PER3_N]             
set_property  IOSTANDARD LVDS [ get_ports PER3_P]             
set_property  IOSTANDARD LVDS [ get_ports MRCLK_N]            
set_property  IOSTANDARD LVDS [ get_ports MRCLK_P]            



## PCIe Slot Misc. Signals
set_property  LOC V24  [ get_ports PCIE_PRSNT_N]       
set_property  LOC U24  [ get_ports PCIE_WAKE_N]         
set_property  LOC AC18 [ get_ports PCIE_PERST_N]        

set_property  IOSTANDARD LVCMOS25 [ get_ports PCIE_PRSNT_N]       
set_property  IOSTANDARD LVCMOS25 [ get_ports PCIE_WAKE_N]         
set_property  IOSTANDARD LVCMOS33 [ get_ports PCIE_PERST_N]        



## SFP Socket Interface
set_property  LOC AE20 [ get_ports SFP_LOS]            
set_property  LOC AA18 [ get_ports SFP_TX_DISABLE]     
set_property  LOC AD19 [ get_ports SFP_TX_FAULT]       
set_property  LOC AA19 [ get_ports SFP_MOD_DEF2]       
set_property  LOC AB19 [ get_ports SFP_MOD_DEF1]       
set_property  LOC AB20 [ get_ports SFP_MOD_DEF0]       
set_property  LOC AD20 [ get_ports SFP_RATE_SEL]       

set_property  IOSTANDARD LVCMOS33 [ get_ports SFP_LOS]            
set_property  IOSTANDARD LVCMOS33 [ get_ports SFP_TX_DISABLE]     
set_property  IOSTANDARD LVCMOS33 [ get_ports SFP_TX_FAULT]       
set_property  IOSTANDARD LVCMOS33 [ get_ports SFP_MOD_DEF2]       
set_property  IOSTANDARD LVCMOS33 [ get_ports SFP_MOD_DEF1]       
set_property  IOSTANDARD LVCMOS33 [ get_ports SFP_MOD_DEF0]       
set_property  IOSTANDARD LVCMOS33 [ get_ports SFP_RATE_SEL]       



## PL DDR3 Interface
set_property LOC J3      [ get_ports ddr_memory_dq[0]]  
set_property LOC L1      [ get_ports ddr_memory_dq[1]] 
set_property LOC K1      [ get_ports ddr_memory_dq[2]]
set_property LOC L3      [ get_ports ddr_memory_dq[3]]
set_property LOC L2      [ get_ports ddr_memory_dq[4]] 
set_property LOC K5      [ get_ports ddr_memory_dq[5]] 
set_property LOC J5      [ get_ports ddr_memory_dq[6]] 
set_property LOC K6      [ get_ports ddr_memory_dq[7]] 
set_property LOC F2      [ get_ports ddr_memory_dq[8]] 
set_property LOC H6      [ get_ports ddr_memory_dq[9]] 
set_property LOC G6      [ get_ports ddr_memory_dq[10]] 
set_property LOC H2      [ get_ports ddr_memory_dq[11]] 
set_property LOC G1      [ get_ports ddr_memory_dq[12]]
set_property LOC H4     [ get_ports ddr_memory_dq[13]] 
set_property LOC H3     [ get_ports ddr_memory_dq[14]] 
set_property LOC G5     [ get_ports ddr_memory_dq[15]] 
set_property LOC F5     [ get_ports ddr_memory_dq[16]]
set_property LOC E5     [ get_ports ddr_memory_dq[17]]
set_property LOC F4     [ get_ports ddr_memory_dq[18]] 
set_property LOC F3     [ get_ports ddr_memory_dq[19]]
set_property LOC D3     [ get_ports ddr_memory_dq[20]] 
set_property LOC E3      [ get_ports ddr_memory_dq[21]] 
set_property LOC E2      [ get_ports ddr_memory_dq[22]] 
set_property LOC E1     [ get_ports ddr_memory_dq[23]] 
set_property LOC B5     [ get_ports ddr_memory_dq[24]] 
set_property LOC B4     [ get_ports ddr_memory_dq[25]] 
set_property LOC C2     [ get_ports ddr_memory_dq[26]] 
set_property LOC C1     [ get_ports ddr_memory_dq[27]] 
set_property LOC B2     [ get_ports ddr_memory_dq[28]] 
set_property LOC B1     [ get_ports ddr_memory_dq[29]] 
set_property LOC A3     [ get_ports ddr_memory_dq[30]] 
set_property LOC A2     [ get_ports ddr_memory_dq[31]] 
set_property LOC J11     [ get_ports ddr_memory_addr[14]]
set_property LOC H11     [ get_ports ddr_memory_addr[13]]
set_property LOC E11     [ get_ports ddr_memory_addr[12]]
set_property LOC D11     [ get_ports ddr_memory_addr[11]]
set_property LOC H12      [ get_ports ddr_memory_addr[10]]
set_property LOC G11      [ get_ports ddr_memory_addr[9]]
set_property LOC E10      [ get_ports ddr_memory_addr[8]]
set_property LOC D10      [ get_ports ddr_memory_addr[7]]
set_property LOC G10     [ get_ports ddr_memory_addr[6]]
set_property LOC F10     [ get_ports ddr_memory_addr[5]]
set_property LOC D9      [ get_ports ddr_memory_addr[4]]
set_property LOC D8      [ get_ports ddr_memory_addr[3]]
set_property LOC F9     [ get_ports ddr_memory_addr[2]]
set_property LOC E8     [ get_ports ddr_memory_addr[1]]
set_property LOC J8     [ get_ports ddr_memory_addr[0]] 
set_property LOC H8     [ get_ports ddr_memory_ba[2]]
set_property LOC F8     [ get_ports ddr_memory_ba[1]]
set_property LOC F7     [ get_ports ddr_memory_ba[0]]
set_property LOC E7     [ get_ports ddr_memory_ras_n]
set_property LOC D6     [ get_ports ddr_memory_cas_n]
set_property LOC H7     [ get_ports ddr_memory_we_n]
set_property LOC G4     [ get_ports ddr_memory_ddr3_rst]
set_property LOC L7     [ get_ports ddr_memory_cke]
set_property LOC J10    [ get_ports ddr_memory_odt]
set_property LOC G7     [ get_ports ddr_memory_cs_n]
set_property LOC J4      [ get_ports ddr_memory_dm[0]]
set_property LOC G2      [ get_ports ddr_memory_dm[1]]
set_property LOC D4     [ get_ports ddr_memory_dm[2]]
set_property LOC C4     [ get_ports ddr_memory_dm[3]]
set_property LOC K3      [ get_ports ddr_memory_dqs[0]]
set_property LOC K2      [ get_ports ddr_memory_dqs_n[0]]
set_property LOC J1     [ get_ports ddr_memory_dqs[1]]
set_property LOC H1     [ get_ports ddr_memory_dqs_n[1]]
set_property LOC E6     [ get_ports ddr_memory_dqs[2]]
set_property LOC D5     [ get_ports ddr_memory_dqs_n[2]]
set_property LOC A5     [ get_ports ddr_memory_dqs[3]]
set_property LOC A4     [ get_ports ddr_memory_dqs_n[3]]
set_property LOC L8     [ get_ports ddr_memory_clk]
set_property LOC K8      [ get_ports ddr_memory_clk_n]

set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[0]]  
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[1]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[2]]
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[3]]
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[4]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[5]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[6]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[7]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[8]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[9]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[10]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[11]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[12]]
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[13]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[14]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[15]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[16]]
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[17]]
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[18]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[19]]
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[20]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[21]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[22]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[23]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[24]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[25]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[26]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[27]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[28]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[29]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[30]] 
set_property IOSTANDARD  SSTL15_T_DCI  [ get_ports ddr_memory_dq[31]] 
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_addr[14]]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_addr[13]]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_addr[12]]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_addr[11]]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_addr[10]]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_addr[9]]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_addr[8]]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_addr[7]]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_addr[6]]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_addr[5]]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_addr[4]]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_addr[3]]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_addr[2]]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_addr[1]]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_addr[0]] 
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_ba[2]]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_ba[1]]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_ba[0]]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_ras_n]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_cas_n]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_we_n]
set_property IOSTANDARD  LVCMOS15 [ get_ports ddr_memory_ddr3_rst]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_cke]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_odt]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_cs_n]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_dm[0]]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_dm[1]]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_dm[2]]
set_property IOSTANDARD  SSTL15 [ get_ports ddr_memory_dm[3]]
set_property IOSTANDARD  DIFF_SSTL15_T_DCI [ get_ports ddr_memory_dqs[0]]
set_property IOSTANDARD  DIFF_SSTL15_T_DCI [ get_ports ddr_memory_dqs_n[0]]
set_property IOSTANDARD  DIFF_SSTL15_T_DCI [ get_ports ddr_memory_dqs[1]]
set_property IOSTANDARD  DIFF_SSTL15_T_DCI [ get_ports ddr_memory_dqs_n[1]]
set_property IOSTANDARD  DIFF_SSTL15_T_DCI [ get_ports ddr_memory_dqs[2]]
set_property IOSTANDARD  DIFF_SSTL15_T_DCI [ get_ports ddr_memory_dqs_n[2]]
set_property IOSTANDARD  DIFF_SSTL15_T_DCI [ get_ports ddr_memory_dqs[3]]
set_property IOSTANDARD  DIFF_SSTL15_T_DCI [ get_ports ddr_memory_dqs_n[3]]
set_property IOSTANDARD  DIFF_SSTL15 [ get_ports ddr_memory_clk]
set_property IOSTANDARD  DIFF_SSTL15 [ get_ports ddr_memory_clk_n]



## FMC HPC Slot
set_property  LOC AD28 [ get_ports CLK0_C2M_N]           
set_property  LOC AC28 [ get_ports CLK0_C2M_P]           
set_property  LOC AG16 [ get_ports CLK0_M2C_N]           
set_property  LOC AG17 [ get_ports CLK0_M2C_P]           
set_property  LOC R26 [ get_ports CLK1_C2M_N]           
set_property  LOC R25 [ get_ports CLK1_C2M_P]           
set_property  LOC U27 [ get_ports CLK1_M2C_N]           
set_property  LOC U26 [ get_ports CLK1_M2C_P]           
set_property  LOC AE23 [ get_ports HA00_CC_N]            
set_property  LOC AD23 [ get_ports HA00_CC_P]            
set_property  LOC AF22 [ get_ports HA01_CC_N]            
set_property  LOC AE22 [ get_ports HA01_CC_P]            
set_property  LOC AD24 [ get_ports HA02_N]               
set_property  LOC AC24 [ get_ports HA02_P]               
set_property  LOC AB22 [ get_ports HA03_N]               
set_property  LOC AB21 [ get_ports HA03_P]               
set_property  LOC AA23 [ get_ports HA04_N]               
set_property  LOC AA22 [ get_ports HA04_P]               
set_property  LOC Y23 [ get_ports HA05_N]               
set_property  LOC Y22 [ get_ports HA05_P]               
set_property  LOC AG25 [ get_ports HA06_N]              
set_property  LOC AG24 [ get_ports HA06_P]
set_property  LOC AF24 [ get_ports HA07_N]               
set_property  LOC AF23 [ get_ports HA07_P]
set_property  LOC AG20 [ get_ports HA08_N]               
set_property  LOC AF20 [ get_ports HA08_P]               
set_property  LOC AB24 [ get_ports HA09_N]               
set_property  LOC AA24 [ get_ports HA09_P]               
set_property  LOC AJ24 [ get_ports HA10_N]               
set_property  LOC AJ23 [ get_ports HA10_P]               
set_property  LOC AK25 [ get_ports HA11_N]               
set_property  LOC AJ25 [ get_ports HA11_P]              
set_property  LOC AK23 [ get_ports HA12_N]               
set_property  LOC AK22 [ get_ports HA12_P]               
set_property  LOC AH24 [ get_ports HA13_N]               
set_property  LOC AH23 [ get_ports HA13_P]               
set_property  LOC AK21 [ get_ports HA14_N]               
set_property  LOC AJ21 [ get_ports HA14_P]               
set_property  LOC AJ19 [ get_ports HA15_N]               
set_property  LOC AH19 [ get_ports HA15_P]               
set_property  LOC AK20 [ get_ports HA16_N]               
set_property  LOC AJ20 [ get_ports HA16_P]               
set_property  LOC AH21 [ get_ports HA17_CC_N]            
set_property  LOC AG21 [ get_ports HA17_CC_P]            
set_property  LOC AK18 [ get_ports HA18_N]               
set_property  LOC AK17 [ get_ports HA18_P]               
set_property  LOC Y21 [ get_ports HA19_N]               
set_property  LOC W21 [ get_ports HA19_P]               
set_property  LOC AG19 [ get_ports HA20_N]               
set_property  LOC AF19 [ get_ports HA20_P]               
set_property  LOC AH22 [ get_ports HA21_N]               
set_property  LOC AG22 [ get_ports HA21_P]               
set_property  LOC AE21 [ get_ports HA22_N]               
set_property  LOC AD21 [ get_ports HA22_P]               
set_property  LOC AC23 [ get_ports HA23_N]               
set_property  LOC AC22 [ get_ports HA23_P]               
set_property  LOC AC27 [ get_ports HB00_CC_N]            
set_property  LOC AB27 [ get_ports HB00_CC_P]            
set_property  LOC AE26 [ get_ports HB01_N]               
set_property  LOC AD25 [ get_ports HB01_P]               
set_property  LOC AA30 [ get_ports HB02_N]               
set_property  LOC Y30 [ get_ports HB02_P]               
set_property  LOC AA29 [ get_ports HB03_N]               
set_property  LOC Y28 [ get_ports HB03_P]               
set_property  LOC AD29 [ get_ports HB04_N]               
set_property  LOC AC29 [ get_ports HB04_P]               
set_property  LOC AB30 [ get_ports HB05_N]               
set_property  LOC AB29 [ get_ports HB05_P]               
set_property  LOC AF28 [ get_ports HB06_CC_N]            
set_property  LOC AE28 [ get_ports HB06_CC_P]            
set_property  LOC AF25 [ get_ports HB07_N]              
set_property  LOC AE25 [ get_ports HB07_P]               
set_property  LOC AG30 [ get_ports HB08_N]               
set_property  LOC AF30 [ get_ports HB08_P]               
set_property  LOC AE30 [ get_ports HB09_N]               
set_property  LOC AD30 [ get_ports HB09_P]               
set_property  LOC AJ29 [ get_ports HB10_N]               
set_property  LOC AJ28 [ get_ports HB10_P]               
set_property  LOC AK30 [ get_ports HB11_N]               
set_property  LOC AJ30 [ get_ports HB11_P]               
set_property  LOC AK28 [ get_ports HB12_N]               
set_property  LOC AK27 [ get_ports HB12_P]               
set_property  LOC AG29 [ get_ports HB13_N]               
set_property  LOC AF29 [ get_ports HB13_P]               
set_property  LOC AH27 [ get_ports HB14_N]               
set_property  LOC AH26 [ get_ports HB14_P]               
set_property  LOC AH29 [ get_ports HB15_N]               
set_property  LOC AH28 [ get_ports HB15_P]               
set_property  LOC AB26 [ get_ports HB16_N]               
set_property  LOC AB25 [ get_ports HB16_P]               
set_property  LOC AF27 [ get_ports HB17_CC_N]            
set_property  LOC AE27 [ get_ports HB17_CC_P]            
set_property  LOC AD26 [ get_ports HB18_N]               
set_property  LOC AC26 [ get_ports HB18_P]               
set_property  LOC AG27 [ get_ports HB19_N]               
set_property  LOC AG26 [ get_ports HB19_P]               
set_property  LOC Y27 [ get_ports HB20_N]               
set_property  LOC Y26 [ get_ports HB20_P]               
set_property  LOC AA28 [ get_ports HB21_N]               
set_property  LOC AA27 [ get_ports HB21_P]               
set_property  LOC AF13 [ get_ports LA00_CC_N]            
set_property  LOC AE13 [ get_ports LA00_CC_P]            
set_property  LOC AG14 [ get_ports LA01_CC_N]            
set_property  LOC AF14 [ get_ports LA01_CC_P]            
set_property  LOC AB14 [ get_ports LA02_N]               
set_property  LOC AB15 [ get_ports LA02_P]               
set_property  LOC AB16 [ get_ports LA03_N]               
set_property  LOC AB17 [ get_ports LA03_P]               
set_property  LOC AC16 [ get_ports LA04_N]               
set_property  LOC AC17 [ get_ports LA04_P]               
set_property  LOC AD15 [ get_ports LA05_N]               
set_property  LOC AD16 [ get_ports LA05_P]               
set_property  LOC AC13 [ get_ports LA06_N]               
set_property  LOC AC14 [ get_ports LA06_P]               
set_property  LOC AF17 [ get_ports LA07_N]               
set_property  LOC AF18 [ get_ports LA07_P]               
set_property  LOC AE17 [ get_ports LA08_N]               
set_property  LOC AE18 [ get_ports LA08_P]               
set_property  LOC AE15 [ get_ports LA09_N]               
set_property  LOC AE16 [ get_ports LA09_P]               
set_property  LOC AK16 [ get_ports LA10_N]               
set_property  LOC AJ16 [ get_ports LA10_P]               
set_property  LOC AH16 [ get_ports LA11_N]               
set_property  LOC AH17 [ get_ports LA11_P]               
set_property  LOC AJ18 [ get_ports LA12_N]               
set_property  LOC AH18 [ get_ports LA12_P]               
set_property  LOC AH13 [ get_ports LA13_N]               
set_property  LOC AH14 [ get_ports LA13_P]               
set_property  LOC AH12 [ get_ports LA14_N]               
set_property  LOC AG12 [ get_ports LA14_P]               
set_property  LOC AK15 [ get_ports LA15_N]               
set_property  LOC AJ15 [ get_ports LA15_P]               
set_property  LOC AD13 [ get_ports LA16_N]               
set_property  LOC AD14 [ get_ports LA16_P]               
set_property  LOC AG15 [ get_ports LA17_CC_N]            
set_property  LOC AF15 [ get_ports LA17_CC_P]            
set_property  LOC V26 [ get_ports LA18_CC_N]            
set_property  LOC U25 [ get_ports LA18_CC_P]            
set_property  LOC AJ13 [ get_ports LA19_N]               
set_property  LOC AJ14 [ get_ports LA19_P]               
set_property  LOC AK12 [ get_ports LA20_N]               
set_property  LOC AK13 [ get_ports LA20_P]               
set_property  LOC AC12 [ get_ports LA21_N]               
set_property  LOC AB12 [ get_ports LA21_P]               
set_property  LOC AF12 [ get_ports LA22_N]               
set_property  LOC AE12 [ get_ports LA22_P]               
set_property  LOC AA14 [ get_ports LA23_N]               
set_property  LOC AA15 [ get_ports LA23_P]               
set_property  LOC U29 [ get_ports LA24_N]               
set_property  LOC T29 [ get_ports LA24_P]               
set_property  LOC T28 [ get_ports LA25_N]               
set_property  LOC R28 [ get_ports LA25_P]               
set_property  LOC W26 [ get_ports LA26_N]               
set_property  LOC W25 [ get_ports LA26_P]               
set_property  LOC W28 [ get_ports LA27_N]               
set_property  LOC V27 [ get_ports LA27_P]               
set_property  LOC W30 [ get_ports LA28_N]               
set_property  LOC W29 [ get_ports LA28_P]               
set_property  LOC U30 [ get_ports LA29_N]               
set_property  LOC T30 [ get_ports LA29_P]               
set_property  LOC R30 [ get_ports LA30_N]               
set_property  LOC P30 [ get_ports LA30_P]               
set_property  LOC V29 [ get_ports LA31_N]               
set_property  LOC V28 [ get_ports LA31_P]               
set_property  LOC P28 [ get_ports LA32_N]               
set_property  LOC N28 [ get_ports LA32_P]               
set_property  LOC P29 [ get_ports LA33_N]               
set_property  LOC N29 [ get_ports LA33_P]               

# Please modify the I/O standards when using the FMC HPC signals as single-ended.
set_property  IOSTANDARD LVDS [ get_ports CLK0_C2M_N]           
set_property  IOSTANDARD LVDS [ get_ports CLK0_C2M_P]           
set_property  IOSTANDARD LVDS [ get_ports CLK0_M2C_N]           
set_property  IOSTANDARD LVDS [ get_ports CLK0_M2C_P]           
set_property  IOSTANDARD LVDS [ get_ports CLK1_C2M_N]           
set_property  IOSTANDARD LVDS [ get_ports CLK1_C2M_P]           
set_property  IOSTANDARD LVDS [ get_ports CLK1_M2C_N]           
set_property  IOSTANDARD LVDS [ get_ports CLK1_M2C_P]           
set_property  IOSTANDARD LVDS [ get_ports HA00_CC_N]            
set_property  IOSTANDARD LVDS [ get_ports HA00_CC_P]            
set_property  IOSTANDARD LVDS [ get_ports HA01_CC_N]            
set_property  IOSTANDARD LVDS [ get_ports HA01_CC_P]            
set_property  IOSTANDARD LVDS [ get_ports HA02_N]               
set_property  IOSTANDARD LVDS [ get_ports HA02_P]               
set_property  IOSTANDARD LVDS [ get_ports HA03_N]               
set_property  IOSTANDARD LVDS [ get_ports HA03_P]               
set_property  IOSTANDARD LVDS [ get_ports HA04_N]               
set_property  IOSTANDARD LVDS [ get_ports HA04_P]               
set_property  IOSTANDARD LVDS [ get_ports HA05_N]               
set_property  IOSTANDARD LVDS [ get_ports HA05_P]               
set_property  IOSTANDARD LVDS [ get_ports HA06_N]              
set_property  IOSTANDARD LVDS [ get_ports HA06_P]
set_property  IOSTANDARD LVDS [ get_ports HA07_N]               
set_property  IOSTANDARD LVDS [ get_ports HA07_P]
set_property  IOSTANDARD LVDS [ get_ports HA08_N]               
set_property  IOSTANDARD LVDS [ get_ports HA08_P]               
set_property  IOSTANDARD LVDS [ get_ports HA09_N]               
set_property  IOSTANDARD LVDS [ get_ports HA09_P]               
set_property  IOSTANDARD LVDS [ get_ports HA10_N]               
set_property  IOSTANDARD LVDS [ get_ports HA10_P]               
set_property  IOSTANDARD LVDS [ get_ports HA11_N]               
set_property  IOSTANDARD LVDS [ get_ports HA11_P]              
set_property  IOSTANDARD LVDS [ get_ports HA12_N]               
set_property  IOSTANDARD LVDS [ get_ports HA12_P]               
set_property  IOSTANDARD LVDS [ get_ports HA13_N]               
set_property  IOSTANDARD LVDS [ get_ports HA13_P]               
set_property  IOSTANDARD LVDS [ get_ports HA14_N]               
set_property  IOSTANDARD LVDS [ get_ports HA14_P]               
set_property  IOSTANDARD LVDS [ get_ports HA15_N]               
set_property  IOSTANDARD LVDS [ get_ports HA15_P]               
set_property  IOSTANDARD LVDS [ get_ports HA16_N]               
set_property  IOSTANDARD LVDS [ get_ports HA16_P]               
set_property  IOSTANDARD LVDS [ get_ports HA17_CC_N]            
set_property  IOSTANDARD LVDS [ get_ports HA17_CC_P]            
set_property  IOSTANDARD LVDS [ get_ports HA18_N]               
set_property  IOSTANDARD LVDS [ get_ports HA18_P]               
set_property  IOSTANDARD LVDS [ get_ports HA19_N]               
set_property  IOSTANDARD LVDS [ get_ports HA19_P]               
set_property  IOSTANDARD LVDS [ get_ports HA20_N]               
set_property  IOSTANDARD LVDS [ get_ports HA20_P]               
set_property  IOSTANDARD LVDS [ get_ports HA21_N]               
set_property  IOSTANDARD LVDS [ get_ports HA21_P]               
set_property  IOSTANDARD LVDS [ get_ports HA22_N]               
set_property  IOSTANDARD LVDS [ get_ports HA22_P]               
set_property  IOSTANDARD LVDS [ get_ports HA23_N]               
set_property  IOSTANDARD LVDS [ get_ports HA23_P]               
set_property  IOSTANDARD LVDS [ get_ports HB00_CC_N]            
set_property  IOSTANDARD LVDS [ get_ports HB00_CC_P]            
set_property  IOSTANDARD LVDS [ get_ports HB01_N]               
set_property  IOSTANDARD LVDS [ get_ports HB01_P]               
set_property  IOSTANDARD LVDS [ get_ports HB02_N]               
set_property  IOSTANDARD LVDS [ get_ports HB02_P]               
set_property  IOSTANDARD LVDS [ get_ports HB03_N]               
set_property  IOSTANDARD LVDS [ get_ports HB03_P]               
set_property  IOSTANDARD LVDS [ get_ports HB04_N]               
set_property  IOSTANDARD LVDS [ get_ports HB04_P]               
set_property  IOSTANDARD LVDS [ get_ports HB05_N]               
set_property  IOSTANDARD LVDS [ get_ports HB05_P]               
set_property  IOSTANDARD LVDS [ get_ports HB06_CC_N]            
set_property  IOSTANDARD LVDS [ get_ports HB06_CC_P]            
set_property  IOSTANDARD LVDS [ get_ports HB07_N]              
set_property  IOSTANDARD LVDS [ get_ports HB07_P]               
set_property  IOSTANDARD LVDS [ get_ports HB08_N]               
set_property  IOSTANDARD LVDS [ get_ports HB08_P]               
set_property  IOSTANDARD LVDS [ get_ports HB09_N]               
set_property  IOSTANDARD LVDS [ get_ports HB09_P]               
set_property  IOSTANDARD LVDS [ get_ports HB10_N]               
set_property  IOSTANDARD LVDS [ get_ports HB10_P]               
set_property  IOSTANDARD LVDS [ get_ports HB11_N]               
set_property  IOSTANDARD LVDS [ get_ports HB11_P]               
set_property  IOSTANDARD LVDS [ get_ports HB12_N]               
set_property  IOSTANDARD LVDS [ get_ports HB12_P]               
set_property  IOSTANDARD LVDS [ get_ports HB13_N]               
set_property  IOSTANDARD LVDS [ get_ports HB13_P]               
set_property  IOSTANDARD LVDS [ get_ports HB14_N]               
set_property  IOSTANDARD LVDS [ get_ports HB14_P]               
set_property  IOSTANDARD LVDS [ get_ports HB15_N]               
set_property  IOSTANDARD LVDS [ get_ports HB15_P]               
set_property  IOSTANDARD LVDS [ get_ports HB16_N]               
set_property  IOSTANDARD LVDS [ get_ports HB16_P]               
set_property  IOSTANDARD LVDS [ get_ports HB17_CC_N]            
set_property  IOSTANDARD LVDS [ get_ports HB17_CC_P]            
set_property  IOSTANDARD LVDS [ get_ports HB18_N]               
set_property  IOSTANDARD LVDS [ get_ports HB18_P]               
set_property  IOSTANDARD LVDS [ get_ports HB19_N]               
set_property  IOSTANDARD LVDS [ get_ports HB19_P]               
set_property  IOSTANDARD LVDS [ get_ports HB20_N]               
set_property  IOSTANDARD LVDS [ get_ports HB20_P]               
set_property  IOSTANDARD LVDS [ get_ports HB21_N]               
set_property  IOSTANDARD LVDS [ get_ports HB21_P]               
set_property  IOSTANDARD LVDS [ get_ports LA00_CC_N]            
set_property  IOSTANDARD LVDS [ get_ports LA00_CC_P]            
set_property  IOSTANDARD LVDS [ get_ports LA01_CC_N]            
set_property  IOSTANDARD LVDS [ get_ports LA01_CC_P]            
set_property  IOSTANDARD LVDS [ get_ports LA02_N]               
set_property  IOSTANDARD LVDS [ get_ports LA02_P]               
set_property  IOSTANDARD LVDS [ get_ports LA03_N]               
set_property  IOSTANDARD LVDS [ get_ports LA03_P]               
set_property  IOSTANDARD LVDS [ get_ports LA04_N]               
set_property  IOSTANDARD LVDS [ get_ports LA04_P]               
set_property  IOSTANDARD LVDS [ get_ports LA05_N]               
set_property  IOSTANDARD LVDS [ get_ports LA05_P]               
set_property  IOSTANDARD LVDS [ get_ports LA06_N]               
set_property  IOSTANDARD LVDS [ get_ports LA06_P]               
set_property  IOSTANDARD LVDS [ get_ports LA07_N]               
set_property  IOSTANDARD LVDS [ get_ports LA07_P]               
set_property  IOSTANDARD LVDS [ get_ports LA08_N]               
set_property  IOSTANDARD LVDS [ get_ports LA08_P]               
set_property  IOSTANDARD LVDS [ get_ports LA09_N]               
set_property  IOSTANDARD LVDS [ get_ports LA09_P]               
set_property  IOSTANDARD LVDS [ get_ports LA10_N]               
set_property  IOSTANDARD LVDS [ get_ports LA10_P]               
set_property  IOSTANDARD LVDS [ get_ports LA11_N]               
set_property  IOSTANDARD LVDS [ get_ports LA11_P]               
set_property  IOSTANDARD LVDS [ get_ports LA12_N]               
set_property  IOSTANDARD LVDS [ get_ports LA12_P]               
set_property  IOSTANDARD LVDS [ get_ports LA13_N]               
set_property  IOSTANDARD LVDS [ get_ports LA13_P]               
set_property  IOSTANDARD LVDS [ get_ports LA14_N]               
set_property  IOSTANDARD LVDS [ get_ports LA14_P]               
set_property  IOSTANDARD LVDS [ get_ports LA15_N]               
set_property  IOSTANDARD LVDS [ get_ports LA15_P]               
set_property  IOSTANDARD LVDS [ get_ports LA16_N]               
set_property  IOSTANDARD LVDS [ get_ports LA16_P]               
set_property  IOSTANDARD LVDS [ get_ports LA17_CC_N]            
set_property  IOSTANDARD LVDS [ get_ports LA17_CC_P]            
set_property  IOSTANDARD LVDS [ get_ports LA18_CC_N]            
set_property  IOSTANDARD LVDS [ get_ports LA18_CC_P]            
set_property  IOSTANDARD LVDS [ get_ports LA19_N]               
set_property  IOSTANDARD LVDS [ get_ports LA19_P]               
set_property  IOSTANDARD LVDS [ get_ports LA20_N]               
set_property  IOSTANDARD LVDS [ get_ports LA20_P]               
set_property  IOSTANDARD LVDS [ get_ports LA21_N]               
set_property  IOSTANDARD LVDS [ get_ports LA21_P]               
set_property  IOSTANDARD LVDS [ get_ports LA22_N]               
set_property  IOSTANDARD LVDS [ get_ports LA22_P]               
set_property  IOSTANDARD LVDS [ get_ports LA23_N]               
set_property  IOSTANDARD LVDS [ get_ports LA23_P]               
set_property  IOSTANDARD LVDS [ get_ports LA24_N]               
set_property  IOSTANDARD LVDS [ get_ports LA24_P]               
set_property  IOSTANDARD LVDS [ get_ports LA25_N]               
set_property  IOSTANDARD LVDS [ get_ports LA25_P]               
set_property  IOSTANDARD LVDS [ get_ports LA26_N]               
set_property  IOSTANDARD LVDS [ get_ports LA26_P]               
set_property  IOSTANDARD LVDS [ get_ports LA27_N]               
set_property  IOSTANDARD LVDS [ get_ports LA27_P]               
set_property  IOSTANDARD LVDS [ get_ports LA28_N]               
set_property  IOSTANDARD LVDS [ get_ports LA28_P]               
set_property  IOSTANDARD LVDS [ get_ports LA29_N]               
set_property  IOSTANDARD LVDS [ get_ports LA29_P]               
set_property  IOSTANDARD LVDS [ get_ports LA30_N]               
set_property  IOSTANDARD LVDS [ get_ports LA30_P]               
set_property  IOSTANDARD LVDS [ get_ports LA31_N]               
set_property  IOSTANDARD LVDS [ get_ports LA31_P]               
set_property  IOSTANDARD LVDS [ get_ports LA32_N]               
set_property  IOSTANDARD LVDS [ get_ports LA32_P]               
set_property  IOSTANDARD LVDS [ get_ports LA33_N]               
set_property  IOSTANDARD LVDS [ get_ports LA33_P]               

set_property LOC AC19 [ get_ports PRSNT_M2C_L]
set_property IOSTANDARD LVCMOS33 [ get_ports PRSNT_M2C_L]

